﻿package com.actionsnippet.parsers{
	
	import flash.utils.*;
	
	public class AsXML {
		
		private var _top:*;
		
		public function AsXML(top:*){
			_top = top;
			_top.setInterval = setInterval;
		};
	   
		public function addClasses(classes:Array){
			for (var i:int = 0; i<classes.length; i++){
				var className:String = getQualifiedClassName(classes[i]);
				_top[className.split("::")[1]] = getDefinitionByName(className) as Class;
			}
       }
	   
		public function runCode(code:XML, target:*=null):void{
			if (target == null) target = _top;
			
			var children:XMLList = code.children();
			for (var i:int = 0; i<children.length(); i++){
				var child:XML = children[i];
				var type:String = child.name();
				if (type == "call"){
					runMethod(target, child);
				}else if (type == "set"){
					setProp(target, child);
				}else if (type == "make"){
					makeInstance(child);
				}
			}
		}
		
		private function makeInstance(code:XML):void{
			var ClassRef:Class;
			if (code.@["class"].indexOf(".") == -1){
				var availableClass:Class = _top[code.@["class"]];
				if (availableClass){
					ClassRef = availableClass;
				}else{
					ClassRef = getDefinitionByName(code.@["class"]) as Class;
				}
			}else{
				ClassRef = getDefinitionByName(code.@["class"]) as Class;
			}
			
			
			// nothing can be passed to the class constructor
			// its not possible with function.apply()
			var instance:*;
			var attributeArgsLength:int = code.@args.toXMLString().length;
			if (attributeArgsLength == 0){
			   instance = _top[code.@reference] = new ClassRef();
			}else{
				 var args:Array;
				 args = code.@args.toString().split(",");
			
				 for (var i:int = 0; i<args.length; i++){
					args[i] = valueType(args[i]);
				 }
				 // oh yeah ;)
				 switch (args.length) {
					  case 1:
						instance = _top[code.@reference] = new ClassRef(args[0]);
						break;
					  case 2:
					    instance = _top[code.@reference] = new ClassRef(args[0], args[1]);
						break;
					  case 3:
					    instance = _top[code.@reference] = new ClassRef(args[0], args[1], args[2]);
						break;
					  case 4:
					    instance = _top[code.@reference] = new ClassRef(args[0], args[1], args[2], args[3]);
						break;
					  case 5:
					    instance = _top[code.@reference] = new ClassRef(args[0], args[1], args[2], args[3], args[4]);
						break;
					  case 6:
					    instance = _top[code.@reference] = new ClassRef(args[0], args[1], args[2], args[3], args[4], args[5]);
						break;
					  case 7:
					    instance = _top[code.@reference] = new ClassRef(args[0], args[1], args[2], args[3], args[4], args[5], args[6]);
						break;
					  case 8:
					    instance = _top[code.@reference] = new ClassRef(args[0], args[1], args[2], args[3], args[4], args[5], args[6], args[7]);
						break;
					  case 9:
					    instance = _top[code.@reference] = new ClassRef(args[0], args[1], args[2], args[3], args[4], args[5], args[6], args[7], args[8]);
						break;
					  case 10:
					    instance = _top[code.@reference] = new ClassRef(args[0], args[1], args[2], args[3], args[4], args[5], args[6], args[7], args[8], args[9]);
						break;
				 }

			}
			runCode(code, instance);
		}
		
		// set a property on an object
		private function setProp(target:*, code:XML):void{
			var attributes:XMLList = code.attributes();	
			for (var i:int = 0; i<attributes.length(); i++){
				var prop:String = attributes[i].name();
				var o:DotSyntax = dotSyntax(target, prop, 1)
				o.obj[o.prop] = valueType(attributes[i]);
				// trace(o.prop, o.obj[o.prop])
			}
		}
		
		private function runMethod(target:*, code:XML):void{
			var i:int = 0;
			var returnValue:*;
			// get a reference to the function
			var method:Function = dotSyntax(target, code.@method);
			// call the function if there are no arguments
			var attributeArgsLength:int = code.@args.toXMLString().length;
			if (attributeArgsLength == 0){
				returnValue = method();
			}else{
			 
			 var args:Array;
			 args = code.@args.toString().split(",");
		
			 for (i = 0; i<args.length; i++){
				args[i] = valueType(args[i]);
			 }
			//  trace(code.@method, args);
			  returnValue = method.apply(null,args);
			}
			
			var prop:String = code.@reference.toXMLString();
			if (prop.length > 0){
				var o:DotSyntax = dotSyntax(_top, prop, 1)
				o.obj[o.prop] = returnValue;
			}
		}
		
		// parse dot syntax 
		private function dotSyntax(target:*, str:String, offset:int = 0):*{
			var path:Array = str.split(".");
			
			if (str == "this"){
				return _top;
			}
			var curr:* = target;
			
			for (var i:int = 0; i<path.length - offset; i++){
				curr = curr[path[i]]
			}
			if (offset != 0){
				//{obj:curr, prop:path[i]}
				return new DotSyntax(curr, path[i]);
			}
			return curr;
		}
		
		private function valueType(val:*):* {
			if (isNaN(Number(val))) {
				   // remove leading and trailing white
				  
				   val = val.replace(/^\s+|\s+$/g,"");
				   // String
				   if (val.charAt(0) == "'"){
					   return val.substr(1, val.length - 2);
				   // Boolean
				   }else if (val == "true"){
			           return true;
				   }else if (val == "false"){
					   return false;
				   }else{
				   // Reference
					 return dotSyntax(_top, val);  
				   }
			} else {
				return Number(val);
			}
			
		}
	}
}

class DotSyntax{
	
	public var obj:*;
	public var prop:String;
	public function DotSyntax(obj:*, prop:String){
		this.obj = obj;
		this.prop = prop;
	}
}

